blob: 07474465c9da096140cbee415c634ebbaf4745ff [file] [log] [blame]
Harald Welte0e6be0e2010-08-25 21:57:59 +02001#!/bin/sh
2### BEGIN INIT INFO
3# Provides: osmo-nitb
4# Required-Start: $network $local_fs
5# Required-Stop:
6# Default-Start: 2 3 4 5
7# Default-Stop: 0 1 6
8# Short-Description: Osmocom GSM network-in-a-box
9# Description: A minimal implementation of the GSM Base Station Controller,
10# Mobile Switching Center, Home Location regster and all other
11# components to run a self-contained GSM network.
12### END INIT INFO
13
14# Author: Harald Welte <laforge@gnumonks.org>
15
16# PATH should only include /usr/* if it runs after the mountnfs.sh script
17PATH=/sbin:/usr/sbin:/bin:/usr/bin
Eric Butlerb5614592012-08-24 20:57:40 -070018NAME=osmo-nitb # Introduce the short server's name here
19DESC="Osmocom GSM Network-in-a-Box" # Introduce a short description here
20DAEMON=/usr/bin/osmo-nitb # Introduce the server's location here
21SCRIPTNAME=/etc/init.d/osmocom-nitb
Harald Welte0e6be0e2010-08-25 21:57:59 +020022
23# Exit if the package is not installed
24[ -x $DAEMON ] || exit 0
25
26# Read configuration variable file if it is present
Eric Butlerb5614592012-08-24 20:57:40 -070027[ -r /etc/default/osmocom-nitb ] && . /etc/default/osmocom-nitb
Harald Welte0e6be0e2010-08-25 21:57:59 +020028
29# Load the VERBOSE setting and other rcS variables
30. /lib/init/vars.sh
31
32# Define LSB log_* functions.
33# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
34. /lib/lsb/init-functions
35
Eric Butler6e7d1372012-08-20 00:21:28 -070036DAEMON_ARGS="$DAEMON_ARGS -D -c $CONFIG_FILE -l $HLR_FILE"
Harald Welte0e6be0e2010-08-25 21:57:59 +020037
38#
39# Function that starts the daemon/service
40#
41do_start()
42{
43 # Return
44 # 0 if daemon has been started
45 # 1 if daemon was already running
46 # 2 if daemon could not be started
Eric Butlerb5614592012-08-24 20:57:40 -070047 start-stop-daemon --start --quiet --exec $DAEMON --test > /dev/null \
Harald Welte0e6be0e2010-08-25 21:57:59 +020048 || return 1
Eric Butlerb5614592012-08-24 20:57:40 -070049 start-stop-daemon --start --quiet --exec $DAEMON -- \
Harald Welte0e6be0e2010-08-25 21:57:59 +020050 $DAEMON_ARGS \
51 || return 2
52 # Add code here, if necessary, that waits for the process to be ready
53 # to handle requests from services started subsequently which depend
54 # on this one. As a last resort, sleep for some time.
55}
56
57#
58# Function that stops the daemon/service
59#
60do_stop()
61{
62 # Return
63 # 0 if daemon has been stopped
64 # 1 if daemon was already stopped
65 # 2 if daemon could not be stopped
66 # other if a failure occurred
Eric Butlerb5614592012-08-24 20:57:40 -070067 start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --name $NAME
Harald Welte0e6be0e2010-08-25 21:57:59 +020068 RETVAL="$?"
69 [ "$RETVAL" = 2 ] && return 2
70 # Wait for children to finish too if this is a daemon that forks
71 # and if the daemon is only ever run from this initscript.
72 # If the above conditions are not satisfied then add some other code
73 # that waits for the process to drop all resources that could be
74 # needed by services started subsequently. A last resort is to
75 # sleep for some time.
76 start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
77 [ "$?" = 2 ] && return 2
Harald Welte0e6be0e2010-08-25 21:57:59 +020078 return "$RETVAL"
79}
80
81#
82# Function that sends a SIGHUP to the daemon/service
83#
84do_reload() {
85 #
86 # If the daemon can reload its configuration without
87 # restarting (for example, when it is sent a SIGHUP),
88 # then implement that here.
89 #
Eric Butlerb5614592012-08-24 20:57:40 -070090 start-stop-daemon --stop --signal 1 --quiet $PIDFILE --name $NAME
Harald Welte0e6be0e2010-08-25 21:57:59 +020091 return 0
92}
93
94case "$1" in
95 start)
96 [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC " "$NAME"
97 do_start
98 case "$?" in
99 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
100 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
101 esac
102 ;;
103 stop)
104 [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
105 do_stop
106 case "$?" in
107 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
108 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
109 esac
110 ;;
111 status)
112 status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
113 ;;
114 #reload|force-reload)
115 #
116 # If do_reload() is not implemented then leave this commented out
117 # and leave 'force-reload' as an alias for 'restart'.
118 #
119 #log_daemon_msg "Reloading $DESC" "$NAME"
120 #do_reload
121 #log_end_msg $?
122 #;;
123 restart|force-reload)
124 #
125 # If the "reload" option is implemented then remove the
126 # 'force-reload' alias
127 #
128 log_daemon_msg "Restarting $DESC" "$NAME"
129 do_stop
130 case "$?" in
131 0|1)
132 do_start
133 case "$?" in
134 0) log_end_msg 0 ;;
135 1) log_end_msg 1 ;; # Old process is still running
136 *) log_end_msg 1 ;; # Failed to start
137 esac
138 ;;
139 *)
140 # Failed to stop
141 log_end_msg 1
142 ;;
143 esac
144 ;;
145 *)
146 #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
147 echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
148 exit 3
149 ;;
150esac
151
152: